import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.io.Writer;
import java.sql.SQLException;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;

import xml2html.*;

// xml2html.RDB2XML饹ˤꡢǡ١򸡺Ƥ줿
// Document֥Ȥ򸵤Transformer饹ȤäHTMLѴ
public class RDB2XMLTransformerServlet extends HttpServlet  {

  String          docDir = null,  // ѤXSLTե뤬ǥ쥯ȥ
                  xslDoc = null;  // ѤXSLTե̾
  ServletContext context = null;  // ServletContextXSLTɤ߹ߤ˻Ѥ

  // ֥åȤϤƼ¹Ԥݤ˵ư᥽å
  public void init()  {

    // ѿν
    // web.xml<init-param>ˤXSLTե뤬Ǽ줿
    // ǥ쥯ȥ򤢤餫ꤷƤ
     docDir = getServletConfig().getInitParameter( "docdir" );
    // ǤXSLTե򤢤餫ꤷƤ
     xslDoc = "rdbFull.xsl";
    // ѡ饹Υ᥽åɤˤServletContext֥Ȥ
    context = getServletContext();

  }

  // ֥åȤ˥뤿Ӥ˵ư᥽å
  public void doGet( HttpServletRequest req, HttpServletResponse res )
                                        throws IOException, ServletException  {
    // Web֥饦ؤHTML
    Writer out = new PrintWriter( new OutputStreamWriter(
                                  res.getOutputStream(), "UTF-8" ) );

    // 餫ǡHTMLʸɤUTF-8Ȥ
    res.setContentType( "text/html;charset=UTF-8" );

    try {

      // xml2html.RDB2XML饹ˤǡ١θ̤XML
      // Document֥Ȥ
      RDB2XML rdb2Xml = new RDB2XML();
      Document    doc = rdb2Xml.getDocument();

      // TransformerѤXSLTɤ߹߸ȤʤReader
      Reader xsl = new InputStreamReader( 
                       context.getResourceAsStream(
                           docDir + xslDoc ), "JISAutoDetect" );

      // TransformerѤXML,XSLTɤ߹߸ꤹ
      // XMLϴ˼Document֥ȤѤ뤿ᡢDOMSource
      // XSLTϥե뤫뤿ᡢStreamSource
      DOMSource       xmlIn = new DOMSource( doc );
      StreamSource    xslIn = new StreamSource( xsl );

      // ǤTransformerˤѴ̤ľWeb֥饦
      StreamResult  htmlOut = new StreamResult( out );

      // TransformerFactoryΥ󥹥󥹤
      TransformerFactory tf = TransformerFactory.newInstance();
      // XSLTɤ߹TransformerΥ󥹥󥹤
      Transformer         t = tf.newTransformer( xslIn );

      // Ѵ̤νˡHTMLȤ
      t.setOutputProperty( "method", "html" );
      // Ѵ̤ʸɤUTF-8Ȥ
      t.setOutputProperty( "encoding", "UTF-8" );

      // XMLɤ߹HTMLѴ
      t.transform( xmlIn, htmlOut );

      out.flush();

    } catch( ParserConfigurationException ex )  {

      throw new ServletException( ex.toString() );

    } catch( SQLException ex )  {

      throw new ServletException( ex.toString() );

    } catch( TransformerConfigurationException ex )  {

      throw new ServletException( ex.toString() );

    } catch( TransformerException ex )  {

      throw new ServletException( ex.toString() );

    } catch( Exception ex )  {

      throw new ServletException( ex.toString() );

    } finally {

      out.close();

    }

  }

}
