package xml2html;

import java.io.File;
import java.io.OutputStreamWriter;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

// ǡ١θ̤XMLXMLDocument֥Ȥˤ
public class RDB2XML  {

  // ǡ١򸡺̤򸵤DOM֥ȤѤ
  // XMLDocument֥Ȥˤ
  public Document getDocument()
                throws SQLException, ParserConfigurationException, Exception  {

    // DocumentBuilderFactory饹Υ󥹥󥹤
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    // Documentμ饹
    Document               doc = dbf.newDocumentBuilder().newDocument();

    // ΤϤ<result>(Element)֥
    // 
    Element result = doc.createElement( "result" );

    // ǡ١ѥ饹(xml2html.DBAccess)Υ󥹥󥹤
    DBAccess da = new DBAccess(
                        new PostgreSQL( "testdb", "userid", "password" )
                  );

    // ǡ١˥bookơ֥򸡺
    ResultSet           rs = da.selectAllColumns( "book" );
    ResultSetMetaData rsmd = rs.getMetaData();

    // ̤ΰʬΥ
    // (<row><column name="̾">ǡ</column>...</row>)
    while( rs.next() )  {

      // 1ʬθ̤Ϥ<row>(Element)֥
      // 
      Element row = doc.createElement( "row" );

      // ƥऴȤθ̤'<column name="̾">ǡ</column>'Ȥ
      int col = rsmd.getColumnCount();
      for( int i = 1; i <= col; i++ )  {

        // ƥΥǡϤ<column>(Element)
        // ֥Ȥ
        Element column = doc.createElement( "column" );

        // ƥ̾Τ<column>name°ͤȤ
        column.setAttribute( "name", rsmd.getColumnName( i ) );
        column.appendChild( doc.createTextNode( rs.getString( i ) ) );

        // <column><row>λҥΡɤɲä
        row.appendChild( column );

      }

      // <row><result>λҥΡɤɲä
      result.appendChild( row );

    }

    // <result>Document֥ȤλҥΡɤɲä
    doc.appendChild( result );

    // ǡ١θ̤Document֥Ȥˤƽλ
    return doc;

  }

  // Υ饹Υƥѥᥤ᥽å(ήγפפŪǺ)
  public static void main( String[] argv ) throws Exception  {

    // Υ饹Ѥƥǡ١θ̤XMLDocument֥
    // 
    RDB2XML       rdb2Xml = new RDB2XML();
    Document          doc = rdb2Xml.getDocument();

    // TransformerѤXML,XSLTɤ߹߸ꤹ
    // XMLϴ˼Document֥ȤѤ뤿ᡢDOMSource
    // XSLTϥե뤫뤿ᡢStreamSource
    DOMSource       xmlIn = new DOMSource( doc );
    StreamSource    xslIn = new StreamSource( new File( "rdbFull.xsl" ) );

    // ǤTransformerˤѴ̤ľܥ󥽡˽Ϥ
    StreamResult      out = new StreamResult( System.out );

    // TransformerFactoryΥ󥹥󥹤
    TransformerFactory tf = TransformerFactory.newInstance();
    // XSLTɤ߹TransformerΥ󥹥󥹤
    // (XSLT˻ꤷʤXMLľܽϤ)
    Transformer         t = tf.newTransformer( xslIn );
    //Transformer       t = tf.newTransformer();

    // 󥽡ɽǤʸɤǥǥȤƽϤ
    t.setOutputProperty( "encoding", System.getProperty( "file.encoding" ) );
    t.setOutputProperty( "indent", "yes" );

    // XMLɤ߹HTMLѴ
    t.transform( xmlIn, out );

  }

}
